#ifndef __dw_h__
#define __dw_h__

#include <stdio.h>


#define DW_FLAG_TRACE   (1 << 0)
#define DW_FLAG_BREAK   (1 << 1)
#define DW_FLAG_CALL    (1 << 2)
#define DW_FLAG_USER(x) (1 << (3+x))

#define DW_ERR_NONE    0
#define DW_ERR_DLOPEN  1
#define DW_ERR_OOM     2
#define DW_ERR_BADLIB  3
#define DW_ERR_BADPTR  4
#define DW_ERR_HASSYM  5

typedef struct _dw_library_t dw_library_t;
typedef struct _dw_syminfo_t dw_syminfo_t;
typedef struct _dw_param_t   dw_param_t;
typedef int                  dw_ret_t;

struct _dw_library_t
{
  char  name[FILENAME_MAX];
  char  dll_path[FILENAME_MAX];
  void* dll_handle;
  int   sym_base;
  int   sym_nb;
};

struct _dw_syminfo_t
{
  char*       name;
  int         flags;
  void**      func;
  char*       ret_type;
  dw_ret_t    ret_default;
  int         param_nb;
  dw_param_t* param;
};

struct _dw_param_t
{
  char* type;
  char* name;
};


dw_library_t* dw_open  (const char* name, const char* dllpath);
int           dw_add   (dw_library_t* lib, dw_syminfo_t* symbols, int count);
int           dw_dump  (dw_library_t* lib);
int           dw_close (dw_library_t* lib);
const char*   dw_error ();

void  dw_do   (dw_syminfo_t* syminfo, ...);
void  dw_do_r (dw_syminfo_t* syminfo, dw_ret_t ret, ...);
void  dw_na   (dw_syminfo_t* syminfo, ...);

#endif /* __dw_h__ */
