#include <stdlib.h>
#include <stdio.h>
#include <dlfcn.h>
#include <sys/time.h>
#include "GL/glx.h"

void* __dll = NULL;
void (*__glXSwapBuffers) (Display * dpy, GLXDrawable drawable) = NULL;


/* This method is automatically called by the DLL linker at link time
 */
void _init()
{
  /* We fetch the original glXSwapBuffers function address in libGL.so
   */
  __dll = dlopen ("/usr/lib/libGL.so", RTLD_LAZY);
  if (__dll == NULL)
  {
    fprintf (stderr, "error: %s\n", dlerror());
    return;
  }
  __glXSwapBuffers = dlsym (__dll, "glXSwapBuffers");
  if (__glXSwapBuffers == NULL)
  {
    fprintf (stderr, "error: %s\n", dlerror());
    return;
  }
}

void _fini()
{
  if (__dll != NULL) dlclose (__dll);
}

void glXSwapBuffers (Display * dpy, GLXDrawable drawable)
{
  static double last = 0.0f;
  double current;
  struct timeval tv;

  if (__glXSwapBuffers == NULL) return;
  (*__glXSwapBuffers)(dpy, drawable);

  /* Fetch time stamp
   */
  gettimeofday (&tv, NULL);
  current = (double)tv.tv_sec + (double)tv.tv_usec * 1.0E-6;
  if (last > 0.0f) printf ("%f\n", current - last);
  last = current;
}
